﻿
init python:
    def rot_reset(trans, st, at):
        if trans.rotate == 360:
            trans.rotate = 0
            return None

    class casino_player:
        def __init__(self, name, cash):
            self.name = name
            self.cash = cash
            self.bet = 0
        def bet_more(self, amount):
            self.bet += amount
            if self.bet > self.cash:
                self.bet = self.cash
        def bet_less(self, amount):
            self.bet -= amount
            if self.bet < 10:
                self.bet = 10


    class roulette_class:
        def __init__(self, player):
            self.player = player
            self.holding = 0
            self.bets = []
            self.speed = 0
            self.rot = 0
            self.t = 0
            self.current = None
            self.y = 0
            self.numbers = [
                [0, "G"],
                [32, "R"], [15, "B"], [19, "R"], [4, "B"], [21, "R"], [2, "B"], [25, "R"], [17, "B"], [34, "R"],
                [6, "B"], [27, "R"], [13, "B"], [36, "R"], [11, "B"], [30, "R"], [8, "B"], [23, "R"], [10, "B"],
                [5, "R"], [24, "B"], [16, "R"], [33, "B"], [1, "R"], [20, "B"], [14, "R"], [31, "B"], [9, "R"],
                [22, "B"], [18, "R"], [29, "B"], [7, "R"], [28, "B"], [12, "R"], [35, "B"], [3, "R"],[26, "B"],
            ]
        def rotate(self):
            self.speed += 100

        def throw(self):
            r = renpy.random.randint(0,36)
            while r == self.current:
                r = renpy.random.randint(0,36)
            self.current = r
            if self.y == 1:
                self.y = 0
            else:
                self.y = 1
        def tick(self):
            self.rot += self.speed
            if self.speed > 1:
                self.speed -= 1

        def place_bet(self, slot):
            if self.holding:
                m = renpy.get_mouse_pos()
                a = [self.holding, slot, m]
                self.holding = 0
                for i in self.bets:
                    if i[1] == slot:
                        i[0] += a[0]
                        i[2] = a[2]
                else:
                    self.bets.append(a)
                    
        def take_bet(self):
            self.holding += self.player.bet
            self.player.cash -= self.player.bet


default player = casino_player("You", 4000)
default roulette = roulette_class(player)

screen roulette_screen(g = roulette):
    modal True
    vbox:
        spacing 10
        text str(g.speed)
        button:
            background "#0009" xalign 1.0
            text "Rotate!"
            action Function(g.rotate)
        button:
            background "#0009" xalign 1.0
            text "Throw!"
            action Function(g.throw)
    
    if g.speed < 20:
        timer 4 repeat True action Function(g.rotate)

    timer 2 repeat True action Function(g.tick)
    fixed:
        fit_first True align .5,.5
        add "roulette/table.png"
        frame:
            align 0.0,0.0 background None offset -129,-32
            frame:
                xysize 708,708 align .5,.5 background "roulette/roulette.png"
                at roulette_rotate(g.rot)
                for n,i in enumerate(g.numbers):
                    frame:
                        xysize 50,600 align .5,.5 background None # "roulette/{}.png".format(i[1])
                        text str(i[0]) align .5,0.0
                        at roulette_transform(n)
                if g.current:
                    frame:
                        ysize 476 align .5,.5 background None
                        at roulette_ball_rotate(g.current)
                        add "roulette/ball.png" align .5,0.0 at roulette_ball_offset(g.y)

        hbox:
            spacing 2 offset 746,339
            style_prefix "roulette"
            button:
                xysize 70,274
                text "0"
                action Function(g.place_bet, 0)
            vbox:
                ysize 276 box_wrap True box_wrap_spacing 2 spacing 2 
                for i in range(1, 37):
                    button:
                        xysize 70,90
                        text str(i)
                        action Function(g.place_bet, i)
            vbox:
                spacing 2
                button:
                    xysize 90,70
                    text "2 to 1" size 25
                    at b_rotate(90)
                    action Function(g.place_bet, "Row 1")
                button:
                    xysize 90,70
                    text "2 to 1" size 25
                    at b_rotate(90)
                    action Function(g.place_bet, "Row 2")
                button:
                    xysize 90,70
                    text "2 to 1" size 25
                    at b_rotate(90)
                    action Function(g.place_bet, "Row 3")

        vbox:
            spacing 2 offset 818,615
            style_prefix "roulette"
            hbox:
                spacing 2
                button:
                    xysize 286,90
                    text "First 12"
                    action Function(g.place_bet, "First 12")
                button:
                    xysize 286,90
                    text "Second 12"
                    action Function(g.place_bet, "Second 12")
                button:
                    xysize 286,90
                    text "Third 12"
                    action Function(g.place_bet, "Third 12")
            hbox:
                spacing 2
                button:
                    xysize 142,90
                    text "1 to 18"
                    action Function(g.place_bet, "1 to 18")
                button:
                    xysize 142,90
                    text "Even"
                    action Function(g.place_bet, "Even")
                button:
                    xysize 142,90
                    # text str(i)
                    action Function(g.place_bet, "Red")
                button:
                    xysize 142,90
                    # text str(i)
                    action Function(g.place_bet, "Black")
                button:
                    xysize 142,90
                    text "Odd"
                    action Function(g.place_bet, "Odd")
                button:
                    xysize 142,90
                    text "19 to 36"
                    action Function(g.place_bet, "19 to 36")

    drag:
        align .5,.98
        style_prefix "roulette1"
        frame:
            background "#0005"
            vbox:
                spacing 6
                text "You have $[g.player.cash]"
                hbox:
                    spacing 6
                    button:
                        text "<"
                        action Function(g.player.bet_less, 10)
                    text str(g.player.bet)
                    button:
                        text ">"
                        action Function(g.player.bet_more, 10)
                    button:
                        text "Bet"
                        action Function(g.take_bet)
    default mpos = renpy.get_mouse_pos()
    if g.holding:
        timer .02 repeat True action SetScreenVariable("mpos", renpy.get_mouse_pos())
        hbox:
            pos mpos
            add "roulette/bet.png"
            text str(g.holding)
    for i in g.bets:
        add "roulette/bet.png" pos i[2] anchor .5,.5


style roulette_button:
    background None
    hover_background "#fff5"
style roulette_text:
    align (.5,.5)
    size 28
style roulette1_button:
    background "#0005"
    hover_background "#0009"
style roulette1_text:
    align (.5,.5)
transform roulette_transform(n):
    subpixel  True
    transform_anchor True
    # alignaround (0.0, 0.5)
    rotate n*9.729
transform b_rotate(r):
    rotate_pad False
    rotate r

transform roulette_rotate(n):
    subpixel  True
    transform_anchor True
    linear 2 rotate n
    function rot_reset
transform roulette_ball_rotate(n):
    subpixel  True
    transform_anchor True
    rotate 760
    easein 3 rotate n*9.729

transform roulette_ball_offset(y):
    subpixel  True
    yoffset -108
    pause 2
    easein .5 yoffset -86
    ease_bounce .5 yoffset y

label roulette_example:
    show screen roulette_screen
    pause

